#####################################################################################
#
# This package is intended to create a basic qmail and vpopmail install.
#
# Vpopmail requires Qmail already installed but Qmail patching requires Vpopmail for
# authentication.  Possibly more.  This rpm will seek to fix build dependancies.
#
#####################################################################################

%define         pversion 1.0
%define         bversion 8
%define 	rpmrelease iworx
%define         release %{bversion}.noarch.%{rpmrelease}

#####################################################################################

# From Vpopmail
%define 	vdir /home/vpopmail
%define 	qdir /var/qmail
%define		iworxdir /home/interworx

#####################################################################################



%define		iworxmysqllibdir %{iworxdir}/mysql/usr/lib64/mysql

%define		ccflags %{optflags} -I%{iworxdir}/mysql/usr/include/mysql
%define		ldflags %{optflags} -L%{iworxmysqllibdir} -lpthread -lm -lrt -lssl -lcrypto -ldl

#####################################################################################

Summary:      InterWorx Base Users
Name:         interworx-prep-vpopmail
Version:      %{pversion}
Release:      %{release}
License:      Commercial
Group:	      Development/Languages
Distribution: InterWorx-HAL
Vendor:       INTERWORX L.L.C
Packager:     Joseph Purkis <jpurkis@interworx.com>

Requires:     zlib-devel
Requires:     iworx-db-55
Requires:     openssl-devel
Requires:     interworx-unix-users

%description
Helper package for building vpopmail.

%pre

if [ -f /usr/local/interworx/iworx.ini] ; then
   echo
   echo "ERROR: InterWorx present on system. Intended for Vpopmail builds only!"
   echo
   exit 1
fi

#####################################################################################

# Try detecting newest gcc (some distributions have got more then one compiler)
# and write it on a temp file

if [ -f %{_tmppath}/%{name}-%{pversion}-gcc ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-gcc ; fi

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with colors ;)
if [ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-show_flags ; fi
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 5

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
if [ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-show_flags ; fi

# We have gcc written in a temp file
export CC="`cat %{_tmppath}/%{name}-%{pversion}-gcc` %{ccflags}"
export LDFLAGS="%{ldflags}"

cd /usr/local/src
wget https://notes.sagredo.eu/files/qmail/tar/netqmail-1.06.tar.gz
tar xzf netqmail-1.06.tar.gz
cd netqmail-1.06
make setup check

#cd /usr/local/src
#wget https://notes.sagredo.eu/files/qmail/tar/vpopmail-5.4.33.tar.gz
#tar xzf vpopmail-5.4.33.tar.gz
#cd vpopmail-5.4.33
#chown -R root.root .
#autoreconf -f -i
#./configure \
#        --enable-qmaildir=/var/qmail/ \
#        --enable-auth-module=mysql \
#        --enable-incdir=%{iworxdir}/mysql/usr/include/mysql \
#        --enable-libdir=%{iworxmysqllibdir}
#make install-strip

%files

%changelog

* Thu Oct 14 2021 Joseph Purkis <jpurkis@interworx.com>
- Added basic build of qmail and a commented vpopmail install that I used for testing.
- This is for use as a dependancy for vpopmail as it looks for the qmaildir and then "$qmaildir"/bin/qmail-newu.
- Did not go beyond this test.
- Qmail on the other hand needs vpopmail before it can be fully patched and compiled.
- Take a look at https://notes.sagredo.eu/en/qmail-notes-185/netqmail-106-basic-setup-42.html,
- a large number of qmail patch's are post vpopmail install.
